
<html lang="{{LANGUAGE}}" xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <meta name="description" content="DCC Validation Service">
    <title>DCC Validation Service</title>

    <!-- Bootstrap core CSS -->
    <link href="../css/bootstrap.min.css" rel="stylesheet" >

    <style>      
      .SUCCESS { background-color:GreenYellow; }
      .ERROR   { background-color:Tomato; }
      .DCC     { color:#C10101; }
      .log {
        padding:.2em;
        border:2px solid black;
        background-color:#FFFFDD;
        font-family:monospace;
        word-wrap: break-word;
        overflow-x: scroll;
        overflow-y: hidden;
      }
    </style>
    <link rel="shortcut icon" type="image/x-icon" href="../img/dcc-favicon.png">
  </head>
  <body style="padding:1em;background-color:#FFF;">
    
    <h1>
      <span class="DCC">D</span>CC{{TITEL}} 
      <span style="font-size:medium;">({{VERSION}})</span>
    </h1>
    
    <div style="margin-bottom:2ex;">
      <input id="XML_file0" type="button" value="{{UPLOAD}}"/> 
      <input id="XML_file"  type="file" style="display:none"  
        accept="application/xml" />
        <strong style="margin-left:5em;" >{{XSD_VERSION}}:</strong>
        <select id="xsd_version" size="1">
          <option>{{INTERNAL}}</option>
        </select>

    </div>
    <div id="resultArea">
      <strong>{{FILE}}: 
        <span id="fname" style="padding:.5ex;"></span>
      </strong>
      <pre id="log" class="log" style="margin-top:.5em;"></pre>
    </div>
    
    
    <script type="text/javascript" charset="utf8" src="../js/jquery-3.4.1.min.js"></script>
    
    <script type="text/javascript" charset="utf8">
      $('#resultArea').hide();
      $('#XML_file0').click(function(){
        $('#resultArea').hide();
        $('#XML_file').click();
      });
      const xsd_list = {{ XSD_VERSIONS|safe }};
      const $xsd_v = $('#xsd_version');
      var xml_data = '';
      for (var i=0; i<xsd_list.length; i++) {
        $('<option>' + xsd_list[i] + '</option>').appendTo($xsd_v);
      }
      function getXSDversion() {
        const idx = $xsd_v.prop('selectedIndex');
        if (idx == 0) return false;
        return $xsd_v.val();
      }
      function _showError(s) {
        $('#fname').addClass('ERROR');
        $('#log').text(s).show();
      }
      function showError(s) {
        _showError('<error>' + s + '</error>')
      }
      function validate(s) {
        const v = getXSDversion();
        const url = '/validate' + (v ? '?v=' + v : '');
        $('#resultArea').show();
        $('#log').text('').hide();
        $('#fname').removeClass('SUCCESS ERROR');
        $.ajax({
          type:'POST',url:url,data:xml_data,
          dataType:'text',
          contentType:'text/xml;charset=utf-8'
        }).done(function(d) {
          if (d.indexOf('<ok/>') > -1) {
            $('#fname').addClass('SUCCESS');
          } else {
            $('#fname').addClass('ERROR');
            _showError(d)
          }
        }).fail(function(jqXHR, status, e) {
          showError(e);
        });                  
      }
      $xsd_v.change(function() {
        if (xml_data) validate(xml_data)
      });
      $('#XML_file').change(function() {
        var file = $(this)[0].files[0];
        xml_data = '';
        $('#fname').text(file.name);
        var reader = new FileReader();
        reader.onload = function(e) {
          var base64 = reader.result.replace(/^data.*base64,/, '');
          xml_data = window.atob(base64);
          validate(xml_data);
        }        
        reader.onerror = function(e) {
          showError(e);
          reader.abort();
        }
        reader.onloadend = function() {
          if (reader.error) showError(reader.error);
        };
        reader.readAsDataURL(file);
      });
    </script>
  </body>
</html>
